/* Reinvoking as "REXX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9"  2>nul
@goto runit */
/*********************************************************************/
/* Licensed Material - Property of IBM                               */
/* 5639-B92 , 5639-D65 (C) Copyright IBM Corp., 1997, 1998           */
/* All rights reserved.                                              */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
trace off;
signal on novalue;
parse source opsys . whoami rest;
/* cobolroot is now set by iwzmIR.CMD */
if opsys = 'OS/2' then
  do;
  env = 'OS2ENVIRONMENT';
  callit = '@Call';
  call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs';
  call SysLoadFuncs;
  end;
else
  do;
  env = 'ENVIRONMENT';
  callit = '@Rexx';
  end;
tempdir = value('TMP',,env);
tempout = SysTempFileName(tempdir'\TM?????.OUT');
tempout2 = SysTempFileName(tempdir'\T2?????.OUT');
xx = Get_MVSINFO();
if xx <> 0 then
  exit 16;
call Set_MVSINFO_Vars;
if tracemod = '*' |,
  wordpos(translate(substr(whoami,lastpos('\',whoami)+1)),tracemod) > 0 then
  do;
  if trace > 3 then trace results;
  if trace > 4 then trace ?;
  end;
parse arg the_input_args;
call traceit 1 'Entry' '!'the_input_args'!';
parse upper arg theargs;
newargs = '';
inquote = 'no';
sepchar = '01'x;
if length(theargs) > 0 then
  do;
  do ii = 1 to length(theargs);
    thechar = substr(theargs,ii,1);
    select;
      when thechar = '"' then
        do;
        if inquote = 'yes' then
          inquote = 'no';
        else
          inquote = 'yes';
        newargs = newargs||thechar;
        end;
      when thechar == ' ' then
        do;
        if inquote = 'yes' then
          newargs = newargs||sepchar;
        else
          newargs = newargs||thechar;
        end;
      otherwise
        newargs = newargs||thechar;
      end;
    end;
  end;
do ii = 1 to 12;
  thearg.ii = word(newargs,ii);
  thearg.ii = translate(thearg.ii,' ',sepchar);
  end;
mvsfile = thearg.1;
workfile = thearg.2;
type = thearg.3;
convhex = thearg.4;
if workfile = '' | mvsfile = '' then
  do;
  call message 01;
  exit 100;
  end;
if type = '' then
  type = 'TEXT';
if type = 'ASCII' then
  type = 'TEXT';
if type = 'TEXT' & convhex = '' then
  convhex = 'CONVERT';
if tempdrive = '' then
  do;
  trydrives = 'C: D: E: F: G: H: I: J: K: L: M: N: O: P: Q: R: S: T: U: V: W: X: Y: Z:';
  useddrives = SysDriveMap(,'used');
  do ii = 1 to words(trydrives);
    tstdrive = word(trydrives,ii);
    if wordpos(tstdrive,useddrives) = 0 then
      do;
      tempdrive = tstdrive;
      leave;
      end;
    end;
  end;
if tempdrive = '' then
  do;
  call message 02;
  exit 116;
  end;
if type = 'TEXT' & (convhex = 'CHECK' | convhex = 'CONVERT') then
  do;
  if convhex <> 'CONVERT' then
    nocopy = 'NC';
  else
    nocopy = '';
  call message 03;
  if mvscomm = 'YES' then
    call iwzmvws.cmd 'IGYFINFO' mvsfile nocopy '>'tempout;
  else
    call iwzmtso.cmd '!!??'tempout'??+IGYFINFO' mvsfile nocopy;
  read_stem.0 = 0;
  xx = linein(tempout,1,0);
  do forever;
    if lines(tempout) = 0 then
      leave;
    read_stem.0 = read_stem.0 + 1;
    nn = read_stem.0;
    read_stem.nn = linein(tempout);
    if substr(read_stem.nn,1,2) = '??' then
      read_stem.nn = substr(read_stem.nn,3);
    end;
  xx = stream(tempout,'C','CLOSE');
  '@erase' tempout;
  if read_stem.0 < 1 then
    do;
    call message 04 mvsfile;
    call message 05;
    exit 120;
    end;
  xx = read_stem.1;
  parse upper var xx rcode recfm lrecl dsorg seqnum alias badhex memexist rest;
  if rcode <> 'OK' then
    do;
    call message 04 mvsfile;
    if rcode = 'ERROR' then
      do;
      call message 06;
      exit 124;
      end;
    else
      do;
      call message 07;
      exit 160;
      end;
    end;
  if substr(mvsfile,1,1) = "'" then
    mvsfile2 = strip(mvsfile,'B',"'")
  else
    mvsfile2 = userid'.'mvsfile;
  parse var mvsfile2 hqual2 '.' lowquals2 '(' member2 ')';
  if dsorg = 'PS' & member2 <> '' then
    do;
    call message 08;
    exit 128;
    end;
  if dsorg = 'PO' & member2 = '' then
    do;
    call message 09;
    exit 132;
    end;
  if substr(recfm,1,1) <> 'F' & substr(recfm,1,1) <> 'V' then
    do;
    call message 10 recfm;
    exit 136;
    end;
  if dsorg <> 'PS' & dsorg <> 'PO' then
    do;
    call message 11 dsorg;
    exit 140;
    end;
  if lrecl = '**' | lrecl = 0 then
    do;
    call message 12 lrecl;
    exit 144;
    end;
  if substr(recfm,1,1) = 'V' then
    do;
    if lrecl <= 4 then
      do;
      call message 13 lrecl;
      exit 148;
      end;
    end;
  if memexist <> 'YES' then
    do;
    call message 14;
    exit 152;
    end;
  if badhex <> 'NO' then
    do;
    call message 15;
    if convhex = 'CHECK' then
      call message 16;
    else
      do;
      call message 17;
      mvsfile = badhex;
      end;
    call sayit;
    end;
  end;
if substr(mvsfile,1,1) = "'" then
  mvsfile = strip(mvsfile,'B',"'")
else
  mvsfile = userid'.'mvsfile;
parse var mvsfile hqual '.' lowquals '(' member ')';
if lowquals = '' then
  do;
  call message 18;
  exit 156;
  end;
workname = tempdrive'\'lowquals
if member <> '' then
  workname = workname'\'member;
if filesys = 'NFS' then
  do;
  fast = ',nofastfilesize';
  timeout = '';
  if readtimeout <> '' & readtimeout > 0 then
    do;
    timeout = timeout',readtimeout('readtimeout')';
    timeout = timeout',attrtimeout('readtimeout')';
    end;
  if writetimeout <> '' & writetimeout > 0 then
    timeout = timeout',writetimeout('writetimeout')';
  end;
numdrive = 1;
drive.1 = tempdrive;
highqual.1 = hqual;
if type = 'TEXT' then
  do;
  trans.1 = 'text,crlf'
  trans2.1 = 'TEXT';
  end;
else
  do;
  trans.1 = 'binary';
  trans2.1 = 'BINARY';
  end;
mapping.1 = 'LOCAL';
sidefile.1 = '';
drivedata.1 = drive.1 highqual.1 trans2.1 mapping.1 sidefile.1;
if numdrive > 0 then
  do;
  do ii = 1 to numdrive;
    select;
      when mapping.ii = 'LOCAL' then
        do;
        if filesys = 'NFS' then
          nfsmap = '';
        else
          sdumap = ''; /* SDU - this may have to change */
        end;
      when mapping.ii = 'FILESYS' then
        do;
        if filesys = 'NFS' then
          do;
          if sidefile.ii = '' then
            nfsmap = ',fileextmap';
          else
            nfsmap = ',fileextmap,sidefile('sidefile.ii')';
          end;
        else
          do;
          /* TO BE DETERMINED */
          end;
        end;
      otherwise
        nfsmap = '';
      end;
    pwdd = substr('********',1,length(pwd));
    if mountcmd = '' | mountcmd = '*' then
      do;
      if opsys = 'OS/2' then
        do;
        if filesys = 'NFS' then
          do;
          '@call iwzmsnd.cmd @mount -l'userid '-p'pwd drive.ii' ',
            system':'highqual.ii','trans.ii||nfsmap||fast||timeout||nfs;
          end;
        else
          do;
          'call dfmdrive assign' drive.ii highqual.ii;
          if trans.ii = 'text,crlf' then
            'cmd.exe /c dfmdrive setparm' drive.ii '"text'sdu'"';
          end;
        end;
      else
        do;
        '@rexx iwzmsnd.cmd @net use' drive.ii' ',
          system':'highqual.ii','trans.ii||nfsmap||fast||timeout||nfs pwd' ',
          '/USER:'userid;
        end;
      end;
    else
      do;
      call iwzmfsr.cmd 'MOUNTCMD' mvsinfo.DRIVE.ii;
      rc = result;
      end;
    mount_rc = rc;
    if mount_rc <> 0 then
      do;
      call message 19 drive.ii;
      exit mount_rc;
      end;
    end;
  end;
'@copy' workname workfile;
copy_rc = rc;
if type = 'TEXT' & convhex = 'CONVERT' then
  do;
  if badhex <> 'NO' then
    call iwzmcls.cmd 'read' workname 'nocheck' hqual;
  end;
if numdrive > 0 then
  do;
  do ii = 1 to numdrive;
    if wordpos(drive.ii,SysDriveMap(,'used')) > 0 then
      do;
      if umountcmd = '' | umountcmd = '*' then
        do;
        if opsys = 'OS/2' then
          do;
          if filesys = 'NFS' then
            '@umount' drive.ii;
          else
            'call dfmdrive release' drive.ii;
          end;
        else
          '@net use' drive.ii '/delete';
        end;
      else
        call 'iwzmfsr.cmd UMOUNTCMD' mvsinfo.DRIVE.ii;
      end;
    end;
  end;
if type = 'TEXT' & convhex = 'CONVERT' then
  do;
  if badhex <> 'NO' then
    do;
    parse upper var badhex dsn1 '(' member ')' dsn2;
    dsname = dsn1||dsn2;
    thecmd = 'DELETE' dsname;
    call message 20 dsname;
    if mvscomm = 'YES' then
      call iwzmvws.cmd thecmd;
    else
      call iwzmtso.cmd '!!'thecmd;
    end;
  end;
exit copy_rc;
/* */
message:
parse arg iwz_message_num,
          iwz_message_arg1 '\\',
          iwz_message_arg2 '\\',
          iwz_message_arg3 '\\',
          iwz_message_arg4 '\\',
          iwz_message_arg5 '\\',
          iwz_message_arg6 '\\',
          iwz_message_arg7 '\\',
          iwz_message_arg8;
select;
  when language = 'ENG' then
    call message_eng;
  when language = 'JPN' then
    call message_jpn;
  otherwise
    call message_eng;
  end;
return;
/* */
message_eng:
select;
 
when iwz_message_num = 1 then do;
call sayit 'Workstation and/or MVS file specification missing';
end;
 
when iwz_message_num = 2 then do;
call sayit 'Cannot find an available temporary drive';
end;
 
when iwz_message_num = 3 then do;
call sayit 'Accessing MVS to get data set/member information';
end;
 
when iwz_message_num = 4 then do;
call sayit 'Cannot determine data set information for' iwz_message_arg1;
end;
 
when iwz_message_num = 5 then do;
call sayit 'MVS job may have abended due to lack of time';
end;
 
when iwz_message_num = 6 then do;
call sayit 'MVS data set may not exist';
end;
 
when iwz_message_num = 7 then do;
call sayit 'Required MVS setup may not be done';
end;
 
when iwz_message_num = 8 then do;
call sayit 'Member not allowed for a non-PDS';
end;
 
when iwz_message_num = 9 then do;
call sayit 'Member missing for a PDS';
end;
 
when iwz_message_num = 10 then do;
call sayit 'Unsupported RECFM' iwz_message_arg1;
end;
 
when iwz_message_num = 11 then do;
call sayit 'Unsupported DSORG' iwz_message_arg1;
end;
 
when iwz_message_num = 12 then do;
call sayit 'Unsupported LRECL' iwz_message_arg1;
end;
 
when iwz_message_num = 13 then do;
call sayit 'Invalid LRECL for variable records' iwz_message_arg1;
end;
 
when iwz_message_num = 14 then do;
call sayit 'MVS data set member does not exist';
end;
 
when iwz_message_num = 15 then do;
call sayit;
call sayit 'Warning: the MVS file contains hex characters either';
call sayit '         below hex 40 or are not printable.';
call sayit;
end;
 
when iwz_message_num = 16 then do;
call sayit 'The copied file on the workstation may not be usable.';
end;
 
when iwz_message_num = 17 then do;
call sayit 'These characters will be converted to null (hex 00).';
end;
 
when iwz_message_num = 18 then do;
call sayit 'Cannot support an MVS file with only one qualifier';
end;
 
when iwz_message_num = 19 then do;
call sayit 'Access of temporary drive' iwz_message_arg1 'failed';
call sayit 'You may not have started access to MVS';
end;
 
when iwz_message_num = 20 then do;
call sayit 'Deleting temporary' iwz_message_arg1 'on MVS';
end;
 
otherwise
call sayit 'Invalid message number' iwz_message_num;
end;
return;
/* */
message_jpn:
call sayit 'Japanese message';
select;
 
when iwz_message_num = 1 then do;
call sayit 'Workstation and/or MVS file specification missing';
end;
 
when iwz_message_num = 2 then do;
call sayit 'Cannot find an available temporary drive';
end;
 
when iwz_message_num = 3 then do;
call sayit 'Accessing MVS to get data set/member information';
end;
 
when iwz_message_num = 4 then do;
call sayit 'Cannot determine data set information for' iwz_message_arg1;
end;
 
when iwz_message_num = 5 then do;
call sayit 'MVS job may have abended due to lack of time';
end;
 
when iwz_message_num = 6 then do;
call sayit 'MVS data set may not exist';
end;
 
when iwz_message_num = 7 then do;
call sayit 'Required MVS setup may not be done';
end;
 
when iwz_message_num = 8 then do;
call sayit 'Member not allowed for a non-PDS';
end;
 
when iwz_message_num = 9 then do;
call sayit 'Member missing for a PDS';
end;
 
when iwz_message_num = 10 then do;
call sayit 'Unsupported RECFM' iwz_message_arg1;
end;
 
when iwz_message_num = 11 then do;
call sayit 'Unsupported DSORG' iwz_message_arg1;
end;
 
when iwz_message_num = 12 then do;
call sayit 'Unsupported LRECL' iwz_message_arg1;
end;
 
when iwz_message_num = 13 then do;
call sayit 'Invalid LRECL for variable records' iwz_message_arg1;
end;
 
when iwz_message_num = 14 then do;
call sayit 'MVS data set member does not exist';
end;
 
when iwz_message_num = 15 then do;
call sayit;
call sayit 'Warning: the MVS file contains hex characters either';
call sayit '         below hex 40 or are not printable.';
call sayit;
end;
 
when iwz_message_num = 16 then do;
call sayit 'The copied file on the workstation may not be usable.';
end;
 
when iwz_message_num = 17 then do;
call sayit 'These characters will be converted to null (hex 00).';
end;
 
when iwz_message_num = 18 then do;
call sayit 'Cannot support an MVS file with only one qualifier';
end;
 
when iwz_message_num = 19 then do;
call sayit 'Access of temporary drive' iwz_message_arg1 'failed';
call sayit 'You may not have started access to MVS';
end;
 
when iwz_message_num = 20 then do;
call sayit 'Deleting temporary' iwz_message_arg1 'on MVS';
end;
 
otherwise
call sayit 'Invalid message number' iwz_message_num;
end;
return;
Get_MVSINFO:
Procedure expose env cobolroot mvsinfo. whoami tempdir trace
 
rtn = 0
null = '0000'x
crlf = '0D0A'x
mvsinfo. = ''
mvsinfoQ = translate('iwzm_MVSINFO.DAT_YALE');
 
oldq = rxqueue('Set',mvsinfoQ)   /* switch to mvsinfo queue */
if queued() = 0 then do                   /* if Q is missing we'll */
  qname = rxqueue('Create',mvsinfoQ)      /* create it and put a bad */
  if qname = mvsinfoQ then push 'Sven'    /* timestamp on it, else */
  else x=rxqueue('Delete',qname)          /* it was in use (we hope) */
  end                                     /* so we'll assume we can */
parse pull mvsstuff; push mvsstuff        /* get/replace Q contents */
parse value mvsstuff with ts (null) . cobolroot (null) mvsstuff /* get */
                                        /* timestamp and cobolroot */
if ts <> 'Sven' then do;
  mvsinfo = cobolroot'\MACROS\MVSINFO.DAT'
  bad_mvsinfo = '    **' whoami '****'crlf'    **error*' mvsinfo,
                'is unavailable, missing or empty **'
 
  x=SysFileTree(mvsinfo,'ts','F')       /* get MVSINFO.DAT's timestamp */
  if ts.0 <> 1 then do
    say bad_mvsinfo
    return 12;
    end
  parse var ts.1 v0 v1 v2 .
  timestamp ='mvsinfo.dat.timestamp' v0 v1 v2
  end;
else
  timestamp = 'Yale'
if timestamp <> ts then do              /* timestamps match? */
  pull mvsstuff                         /* no, remove bad contents */
  rtn = "iwzmIR.CMD"()                /* ask for new stuff */
  if rtn = 0 then do
    parse pull mvsstuff; push mvsstuff    /* get/replace Q contents */
                                        /* remove timestamp and     */
                                        /* cobolroot                */
    parse value mvsstuff with . (null) . cobolroot ( null) mvsstuff
    end
  end
qname = rxqueue('Set',oldq)      /* restore normal queue */
 
do while (mvsstuff<>'') & (rtn=0)   /* mvsinfo. structure */
  parse value mvsstuff with key val (null) mvsstuff
  if mvsinfo.key = '' then do       /* e.g. mvsinfo.TYPE='' */
    mvsinfo.KEYS = mvsinfo.KEYS key /* no substitution for KEYS */
    mvsinfo.key.1 = val             /* e.g. mvsinfo.TYPE.1=val  */
    mvsinfo.key = 1                 /* e.g. mvsinfo.TYPE=1      */
    end
  else do
    x = mvsinfo.key + 1             /* e.g. mvsinfo.TYPE+1     */
    mvsinfo.key.x = val             /* e.g. mvsinfo.TYPE.2=val */
    mvsinfo.key = x                 /* e.g. mvsinfo.TYPE=2     */
    end
  end
 
return rtn
 
Set_MVSINFO_Vars:
 
 parse var mvsinfo.CLOSECMD.1 closecmd;
 parse var mvsinfo.CLOSEFILE.1 closefile;
 parse var mvsinfo.FILESYS.1 filesys accessmon testaccess;
 parse var mvsinfo.FSSTARTCMD.1 fsstartcmd;
 parse var mvsinfo.FSSTOPCMD.1 fsstopcmd;
 parse var mvsinfo.HEADER.1 header;
 parse var mvsinfo.JOBLOG.1 joblog;
 parse var mvsinfo.MAXCMD.1 maxcmd;
 parse var mvsinfo.LANGUAGE.1 language;
 parse var mvsinfo.MOUNTCMD.1 mountcmd;
 parse var mvsinfo.MVSCOMM.1 mvscomm;
 parse var mvsinfo.iwzmEDT.1 iwzmedt;
 parse var mvsinfo.NFS.1 nfs;
 parse var mvsinfo.NULLSTDIN.1 nullstdin;
 parse var mvsinfo.OUTSHOW.1 outshow;
 parse var mvsinfo.PROTSAVE.1 protsave tempmult;
 parse var mvsinfo.PWD.1 pwd pwdasis pwdt pwde;
 parse var mvsinfo.READTIMEOUT.1 readtimeout;
 parse var mvsinfo.REXECCMD.1 rexeccmd;
 parse var mvsinfo.SDU.1 sdu;
 parse var mvsinfo.SIGYCLST.1 sigyclst;
 parse var mvsinfo.SYSPROC.1 sysproc;
 parse var mvsinfo.SYSTEM.1 system;
 parse var mvsinfo.TEMPDRIVE.1 tempdrive;
 parse var mvsinfo.TEMPDATA.1 tempdata;
 parse var mvsinfo.TESTFILE.1 testfile;
 parse var mvsinfo.TRACE.1 trace tracekeep;
 parse var mvsinfo.TRACECMD.1 tracecmd;
 parse var mvsinfo.TRACEMOD.1 tracemod;
 parse var mvsinfo.UMOUNTCMD.1 umountcmd;
 parse var mvsinfo.USERID.1 userid;
 parse var mvsinfo.WORKSYS.1 worksys;
 parse var mvsinfo.WRITETIMEOUT.1 writetimeout;
 
 parse var mvsinfo.DRIVE numdrive;
 if numdrive = '' then
   numdrive = 0;
 do ii = 1 to numdrive;
   parse var mvsinfo.DRIVE.ii,
             drive.ii highqual.ii trans.ii mapping.ii sidefile.ii;
   end;
 
 parse var mvsinfo.TYPE numtype;
 if numtype = '' then
   numtype = 0;
 do ii = 1 to numtype;
   parse var mvsinfo.TYPE.ii type.ii ext.ii;
   end;
 
return
 
/* */
Traceit:
 parse arg iwz_trc_level iwz_trc_message;
 if iwz_trc_level > trace then
   return;
 if pwd <> '********' & pwd <> '++++++++' & pwd <> '========' then
   do;
   do forever;
     if pos(pwd,iwz_trc_message) = 0 then
       leave;
     parse var iwz_trc_message iwz_trc_message1 (pwd) iwz_trc_message2;
     iwz_trc_message = iwz_trc_message1||'********'||iwz_trc_message2
     end;
   end
 iwz_trc_message = date('O') time('L') whoami':' iwz_trc_message;
 xx = lineout(tempdir'\iwzmTRC.TRC',iwz_trc_message);
 xx = stream(tempdir'\iwzmTRC.TRC','C','CLOSE');
 if tracecmd <> '' then
   interpret tracecmd;
return;
 
/* */
sayit:
 parse arg iwz_sayit_arg;
 if trace > 2 then
   call traceit 3 '--->' iwz_sayit_arg;
 say iwz_sayit_arg;
return;
/*
:runit
@rexx %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
@rem */
